% lab19_ex_fmradio_decoder_stereo.m
% In Octave: >>pkg load signal[ENTER]
clear all; close all;

method = 1;     % L-R demodulation method:
                % 1=pilot^2, 2=BP(pilot)+PLL, 3=Costas L-R, 4=(L-R)^2 + PLL
BP = 1;         % 0/1 - testing necessity of using BP filter in methods #1,2
fmradio_params  % file with parameters: frequency values, filter weights, etc.
  
  [y,fs] = audioread('FMRadio_IQ_250kHz_LR.wav');  % read Goodbye+Danke, L, R, LR
% [y,fs] = audioread('FMRadio_IQ_250kHz_Calibrate.wav');  % swing in one channel
% [y,fs] = audioread('SDRSharp_FMRadio_96000kHz_IQ_one.wav',[1,10*250000]);
y = y(:,1) + sqrt(-1)*y(:,2);                      % [I,Q] --> complex [I+j*Q]

% DECODING MONO L+R SIGNAL
dy = (y(2:end).*conj(y(1:end-1)));       % calculation of instantaneous frequency
y = atan2(imag(dy), real(dy)); clear dy; % frequency demodulation
ym = filter( hLPaudio, 1, y );           % low-pass filtration of L+R (mono) signal
ym = ym(1:fs/faudio:end);                % leaving only every fs/faudio-th sample
disp('LISTENING MONO: Left + Right'); sound(ym,faudio); pause % listening to L+R
w = ym-mean(ym); w=w/max(abs(w)); audiowrite('FM_mono.wav',w,faudio); clear w;

% DECODING L-R SIGNAL
if(method==1) % pilot raised to the square and normalized
  p = filter(hBP19,1,y);                         % band-pass filtering around 19kHz
  p = p.^2;                                      % raising to the square
  p = p - mean(p(3*L+1:23*L)); T=fs/fstereo;     % mean subtraction
  eng = sum( p(3*L+1:3*L+1+round(100*T)-1).^2 ) / round(100*T); A = 2*sqrt(eng/2);
  c38 = p/A;                                     % normalization to -1/+1
  if(BP==1) y38 = filter(hBP38,1,y);             % optional band-pass filtering 38 kHz
  else      y38=[ zeros(L/2,1); y(1:end-L/2) ];  % only delay
  end;      offs=L/2;                            % introduced offset                      
  ys = 2*y38.*c38;                               % frequency-down conversion                          
  ys = filter(hLPaudio,1,ys);                    % low-pass filtering
end
if(method==2) % pilot + PLL
  p = filter(hBP19,1,y);                             % extracting 19 kHz pilot
  theta = zeros(1,length(p)+1); omega = theta; omega(1) = 2*pi*(fpilot+50)/fs; 
  mi1 = 0.0011; mi2 = 5.6859e-07; p=p/max(abs(p));   %#
  for n = 1 : length(p)                              %# 
      pherr = -p(n)*sin(theta(n));                   %# double PLL on 19 kHz
      theta(n+1) = theta(n) + omega(n) + mi1*pherr;  %# 
      omega(n+1) = omega(n) + mi2*pherr;             %#
  end                                                %#
  c38(:,1) = cos(2*theta(1:end-1));                  %# carrier 38 kHz
  if(BP==1) y38 = filter(hBP38,1,y);                 % band-pass filtering 38 kHz
  else      y38=[ zeros(L/2,1); y(1:end-L/2) ];      % or delay
  end;      offs = L/2;                              % introduced offset
  ys = 2*real(y38.*c38); clear p y38 c38 theta;      % 38 kHz --> 0 kHz
  ys = filter( hLPaudio, 1, ys );                    % low-pass filtration of L-R
  figure; plot(fs*omega/(2*pi)); title('fpilot(n)'); pause; clear omega;
end  
if(method==3) % Costas loop working on 38 kHz
  y38 = filter(hBP38,1,y);  offs=0;                  % band-pass filtering 38 kHz
  y38 = hilbert( y38 );                              % analytic signal
  theta = zeros(1,length(y38)+1); omega=theta; omega(1)=2*pi*(2*fpilot+25)/fs;
  mi1 = 0.0011; mi2 = 5.6859e-07;                        %#
  for n = 1 : length(y)                                  %# Costas loop
      bb(n) = y38(n) * exp(-j*theta(n));                 %# base-band signal
      delta(n) = real( bb(n) ).*imag( bb(n) ) / (bb(n).*conj(bb(n))); % error
      theta(n+1) = theta(n) + omega(n) + mi1*delta(n);   %# 1-st update
      omega(n+1) = omega(n) + mi2*delta(n);              %# 2-nd update
  end                                                    %#
  ys = real( bb ); ys = ys'; clear bb delta theta        %# frequency-down L-R
  figure; plot(fs*omega/(2*pi)); title('fstereo(n)'); pause; clear omega
end
if(method==4) % (L-R)^2 + PLL
  y38 = filter(hBP38,1,y); offs = L/2; % extracting L-R signal, band-pass around 38kHz 
  y76 = y38.^2;                        % raising to the square
  y76 = filter(hBP76,1,y76);           % narrow band-pass filtering around 76kHz
  theta = zeros(1,length(y76)+1); omega = theta; pherr=theta; omega(1) = 2*pi*(4*fpilot+25)/fs; 
  mi1 = 5*0.0028; mi2 = 5*3.8527e-06; y76=y76/max(abs(y76));  %#
  for n = 1 : length(y76)                                     %#
      pherr(n) = -y76(n)*sin(theta(n));                       %# double PLL
      theta(n+1) = theta(n) + omega(n) + mi1*pherr(n);        %# on 76 kHz
      omega(n+1) = omega(n) + mi2*pherr(n);                   %#
  end                                                         %#
  c38 = cos( theta(1:end-1)/2 );                              %# 76 kHz --> 38 kHz 
  c38 = [c38(L/2+1:end)'; zeros(L/2,1)]; clear pherr theta    % delay compensation
  ys = 2*real(y38 .* c38); % freq-down, two choices: +/-2 (sin(a)=0 for a=0, +pi) 
  ys = filter( hLPaudio, 1, ys ); clear y38 c38; % low-pass filtration of L-R signal
  figure; plot(fs*omega/(2*pi)); title('fc(n)'); pause; clear omega
end
ys = ys(1:fs/faudio:end); % leaving every fs/faudio-th sample of (L-R)

% DECODING L,R FROM (L+R) AND (L_R)
% Time synchronization of L+R and L-R signals (taking into account delay of L-R)
delay = offs/(fs/faudio); ym = ym(1:end-delay); ys=ys(1+delay:end);
% Recovering L and R channel
n=1:min(length(ym),length(ys));
y1 = 0.5*( ym(n) + ys(n) ); y2 = 0.5*( ym(n) - ys(n) ); clear ym ys;
figure; subplot(211); plot(y1); title('y1'); subplot(212); plot(y2); title('y2'); pause
% De-emphasis: flat freq-response to 2.1 kHz, then decreasing 20 dB / decade
% y1 = filter(b_de,a_de,y1); y2 = filter(b_de,a_de,y2);
% Listening to L and R channel separately
z = zeros(length(y1),1);
disp('LISTENING: Left channel'); sound([y1 z ],faudio);
figure; plot(y1); title('L'); pause;
disp('LISTENING: Right channel'); sound([z  y2],faudio);
figure; plot(y2); title('R'); pause
disp('LISTENING: Stereo'); sound([y1 y2],faudio); pause
% Writing stereo signal to disc
maxi = max( max(abs(y1)),max(abs(y2)) );
audiowrite('FM_Radio_stereo.wav',  [ y1/maxi y2/maxi ], faudio ); % clear y1 y2;